/******************************************************************************
 * File: palm.h 
 * 
 * Copyright (C) 2001 Angus Ainslie <aasoft@netscape.net>
 * 
 * This is a part of PalmPix Archimage.pdb database decoder
 * 
 *       This program is free software; you can redistribute it and/or modify
 *       it for use in non-commercial products. Any commercial use of this 
 *       code or code derived from this code requires my permission.
 * 
 *       This program is distributed in the hope that it will be useful,
 *       but WITHOUT ANY WARRANTY; without even the implied warranty of
 *       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 *****************************************************************************/

typedef unsigned char UInt8;
typedef char Int8;
typedef unsigned short UInt16;
typedef short Int16;
typedef unsigned int UInt32;
typedef long Int32;

#ifdef __QNXNTO__
#include <_pack1.h>
#else
#pragma pack(1)
#endif

#ifdef __GNUC__

#define BI_RGB  0
#define BI_RLE8 1
#define BI_RLE4 2

#endif

typedef struct {
   UInt32 nextRecordListID;
   UInt16 numRecords;
//   UInt16 firstEntry;   
} RecordListType;

typedef struct {
   char name[32];
   UInt16 attributes, version;
   UInt32 creationDate;
   UInt32 modificationDate;
   UInt32 lastBackupDate;
   UInt32 modificationNumber;
   UInt32 appInfoID;
   UInt32 sortInfoID;
   UInt32 type;
   UInt32 creator;
   UInt32 uniqueIDSeed;
   RecordListType recordList;
} DatabaseHdrType;

typedef struct {
   UInt32 localChunkID;
   UInt8 attributes;
   UInt8 uniqueID[3];
} RecordEntryType;

typedef struct dirEntry_tag {
   UInt32 offset;
   UInt16 size;
} dirEntry_t;

typedef struct BitmapFileHeader_tag {       /* bmfh */
   UInt16 type;
   UInt32 size;
   UInt16 reserved1;
   UInt16 reserved2;
   UInt32 offBits;
} BitmapFileHeader_t;

typedef struct BitmapInfoHeader_tag {    /* bmih */
   UInt32   size;
   UInt32   width;
   UInt32   height;
   UInt16   planes;
   UInt16   bitCount;
   UInt32   compression;
   UInt32   sizeImage;
   UInt32   XpelsPerMeter;
   UInt32   YpelsPerMeter;
   UInt32   clrUsed;
   UInt32   clrImportant;
} BitmapInfoHeader_t;

typedef struct RGBquad_tag {       /* rgbq */
   UInt8 b;
   UInt8 g;
   UInt8 r;
   UInt8 res;
} RGBquad_t;

typedef struct RGB_tag {       /* rgbq */
   UInt8 r;
   UInt8 g;
   UInt8 b;
} RGB_t;

typedef struct RGB_back_tag {       /* rgbq */
   UInt8 b;
   UInt8 g;
   UInt8 r;
} RGB_back_t;

#ifdef __QNXNTO__
#include <_packpop.h>
#else
#pragma pack()
#endif
